float4x4 ModelViewProj;
float4x4 ModelView;

float4 ProjectBias;

struct InputVertex
{
	float4 Pos : POSITION;	
};

struct OutputVertex
{
	float4 Pos : POSITION;	
	float4 FrontCoord : TEXCOORD0;	
	float4 ProjTex : TEXCOORD1;		
};


void main(in InputVertex src, out OutputVertex dest)
{
	dest.Pos = mul(src.Pos, ModelViewProj);	
	dest.FrontCoord = mul(src.Pos, ModelView);	
	// texcoord for projective texturing (texture containing position 
	// of background objects in view space)
	dest.ProjTex.x = dest.Pos.w * ProjectBias.x + dest.Pos.x;
	dest.ProjTex.y = dest.Pos.w * ProjectBias.y - dest.Pos.y;
	dest.ProjTex.z = 2.f * dest.Pos.w;
	dest.ProjTex.w = 2.f * dest.Pos.w;
	
}